
;        ViewMem
;  by Antoine RICHARD

; This small (726 bytes) program allows you to see any part of your TI-85
; memory. It displays every numbers in decimal (not in hexadecimal).
; It needs ZShell 4.0 to work.
;
;
; The numbers on the first line are, from left to right :
;  -The address of where's the cursor (white on black)
;  -The memory page
;  -The value of the byte the cursor is on
;  -The 2 bytes = 16 bits value the cursor is on
;   (cursor byte  + 256 x byte just right)
;
;
;
; Key used :
;
; 0 to 9 : Start entering a new address
;          The address must be a five figure number under 65536
;          Type 0 at the beginning if it's not
;
; Arrows : move cursor
;
; 2nd    : go up  one screen
; ALPHA  : go down one screen
;
; ( and ) : Change memory page
;           Only useful from 16384 (= 4000 h) to 32767 (= 7FFF h)
;           There are only 8 memory pages
;
; Exit : When changing the address : cancel it
;        Or else : back to ZShell
;
;
;
;
; How to use the V.A.T. to find a variable:
;
; First go to the V.A.T. at 64111 . In the V.A.T. everything (including
; address and name) is written upside down.
;
; Here's what's stored in the V.A.T. for each variable :
; * The first byte is the type of variable :
;      REAL :  0 : black square
;      CPLX :  1 : bold "b"
;      VECT :  2 : bold "o"
;      LIST :  4 : bold "h"
;      MATR :  6 : bold up arrow
;      CONS :  8 : integral symbol
;      EQU  : 10 : bold "A"
;      STRN : 12 : bold "C"
;      GDB  : 15 : bold "F"
;      PIC  : 17 : little "-1"
;      PRGM : 18 : little "2",square symbol
; * The second and third byte are the address where's the variable
;   It's written upside down, the two address bytes are switched
; * The fourth byte is the lenght (number of characters) of the variable name
; * Bytes fifth and more are the name itself of the variable
;
; The first variable is ZShell, secondly there is a program called "!",
; followed by a program called "#", then there is Ans (last result),
; afterwards are your own variables.
; "#" is the last entry (it's a compiled program)
; "!" is the current entry (it's a non compiled program)
; In the main screen, when you press ENTER , the data in "!" is copied in "#"
; and when you pressed 2nd ENTER, the data in "#" is copied in "!".
;
; The address of the end of the V.A.T. is stored
; in a pointer at the address 35819=8BEB h.
; VAT_END=35819=$8BEB is not directly the end of the vat,
; it's where you can find where is it.
; To be exact it points to a byte just out of the V.A.T..
;
;
; When you go to the address of the variable, the first two bytes are the
; lenght of the variable, and just after you'll find the content
; of the variable itself.
;














#include ti-85.h


data_p = TEXT_MEM

debut_ecran = data_p +10 ; 2 bytes long
fin_ecran   = data_p +12 ; 2 bytes long
cursor_addr  = data_p +14 ; 2 bytes long
bal_y         = data_p +16 ; 1 bytes long
bal_x          = data_p +17 ; 1 bytes long
bal_ecran       = data_p +18 ; 2 bytes long
temp_cursor_addr = data_p +20 ; 2 bytes long
key_pressed = data_p +22 ; 1 bytes long
c10c        = data_p +23 ; 1 bytes long

.org 0
.db  "Memory reader",0



   ld IY,33606  ; normaly IY=33606=$8346 is already true

;;;res 1,(IY+05) ; menu text only 6 row (not 7)   (j' ai essay et a marche)
   res 3,(IY+05) ; text black on white            (verifi aussi)
                 ; and menu text printed over current screen  (verifi aussi)
                 ; (la ligne au dessus est toujours blanche, pour la ligne du dessous on peut choisir)
   res 1,(IY+0D) ; don't alter text memory




;;;ld A,(ZS_BITS)
;;;set 0,A         ; checksum again when coming back to ZShell
;;;ld (ZS_BITS),A



  ld HL,(debut_ecran)
  ld DE,73
  add HL,DE
  ld (cursor_addr),HL


   ROM_CALL(CLEARLCD)


debut_dess_ecran:

   ld HL,(debut_ecran)
   ld (bal_ecran),HL
   ld DE,146        ;   146 = 21*7-1
   add HL,DE
   ld (fin_ecran),HL

   ld BC,1           ; x=B=0   y=C=1
   ld (bal_y),BC





dess_ecran_loop:

   ld BC,(bal_y)
   ld (CURSOR_ROW),BC

   ld HL,(bal_ecran)
   ld DE,(cursor_addr)
   call CP_HL_DE
   res 3,(IY+05) ; text black on white
   jr nz,pas_sur_le_cur
   set 3,(IY+05) ; text white on black
pas_sur_le_cur:

   ld BC,(bal_y)
   ld (CURSOR_ROW),BC
   ld A,(HL)

   ROM_CALL(TR_CHARPUT) ; TR or TX ?   ( TX make the screen scroll)

   res 3,(IY+05) ; text black on white

   ld HL,(bal_ecran)
   ld DE,(fin_ecran)
   call CP_HL_DE
   jr z,apres_dess_ecran


   ld HL,(bal_ecran)
   inc HL
   ld (bal_ecran),HL

   ld A,(bal_x)
   inc A
   ld (bal_x),A
   cp 21
   jr nz,no_inc_bal_y
   ld A,0
   ld (bal_x),A
   ld A,(bal_y)
   inc A
   ld (bal_y),A
no_inc_bal_y:

   JUMP_(dess_ecran_loop)

apres_dess_ecran:

  ld BC,$1000         ; x=B=16  y=C=0
  ld (CURSOR_ROW),BC
  ld HL,(cursor_addr)
  call LD_HL_MHL
  ROM_CALL(D_HL_DECI)


  ld BC,$0900         ; x=B=9  y=C=0
  ld (CURSOR_ROW),BC
  ld HL,(cursor_addr)
  ld A,(HL)
  ld L,A
  ld H,0
  ROM_CALL(D_HL_DECI)


  ld BC,$0300         ; x=B=3  y=C=0
  ld (CURSOR_ROW),BC
  in A,(5)
  ld L,A
  ld H,0
  ROM_CALL(D_HL_DECI)


  ld BC,0           ; x=B=0  y=C=0
  ld (CURSOR_ROW),BC
  ld HL,(cursor_addr)
  set 3,(IY+05) ; text white on black
  ROM_CALL(D_HL_DECI)
  res 3,(IY+05) ; text black on white



  call GET_KEY
  ld (key_pressed),A
  cp 55   ; key exit
  ret z
  cp 04
  CALL_Z(key_up)
  ld A,(key_pressed)
  cp 01
  CALL_Z(key_down)
  ld A,(key_pressed)
  cp 02
  CALL_Z(key_left)
  ld A,(key_pressed)
  cp 03
  CALL_Z(key_right)
  ld A,(key_pressed)
  cp 54
  CALL_Z(key_2nd)
  ld A,(key_pressed)
  cp 48
  CALL_Z(key_alpha)
  ld A,(key_pressed)
  cp 21  ; key )
  CALL_Z(key_imp)
  ld A,(key_pressed)
  cp 29  ; key (
  CALL_Z(key_dmp)



  ld A,(key_pressed)
  cp 33
  CALL_Z(key_num)
  ld A,(key_pressed)
  cp 34
  CALL_Z(key_num)
  ld A,(key_pressed)
  cp 35
  CALL_Z(key_num)
  ld A,(key_pressed)
  cp 36
  CALL_Z(key_num)
  ld A,(key_pressed)
  cp 26
  CALL_Z(key_num)
  ld A,(key_pressed)
  cp 27
  CALL_Z(key_num)
  ld A,(key_pressed)
  cp 28
  CALL_Z(key_num)
  ld A,(key_pressed)
  cp 18
  CALL_Z(key_num)
  ld A,(key_pressed)
  cp 19
  CALL_Z(key_num)
  ld A,(key_pressed)
  cp 20
  CALL_Z(key_num)



   JUMP_(debut_dess_ecran)


key_up:
  ld HL,(cursor_addr)
  ld DE,21
  cp 0          ; reset carry flag
  sbc HL,DE
  jr test_cursor_dans

key_down:
  ld HL,(cursor_addr)
  ld DE,21
  add HL,DE
  jr test_cursor_dans

key_left:
  ld HL,(cursor_addr)
  dec HL
  jr test_cursor_dans

key_right:
  ld HL,(cursor_addr)
  inc HL
  jr test_cursor_dans

test_cursor_dans:
  ld (cursor_addr),HL
  ld DE,(debut_ecran)
  cp 0
  sbc HL,DE
  ld A,L
  cp 147
  ret c
  cp 200
  jr c,ecran_apres
  jr ecran_avant



key_2nd:
  ld HL,(cursor_addr)
  ld DE,147
  cp 0      ; reset carry flag
  sbc HL,DE
  ld (cursor_addr),HL
ecran_avant:
  ld HL,(debut_ecran)
  ld DE,147
  cp 0      ; reset carry flag
  sbc HL,DE
  ld (debut_ecran),HL
  ret

key_alpha:
  ld HL,(cursor_addr)
  ld DE,147
  add HL,DE
  ld (cursor_addr),HL
ecran_apres:
  ld HL,(debut_ecran)
  ld DE,147
  add HL,DE
  ld (debut_ecran),HL
  ret



key_imp:
   in A,(5)
   inc A
   out (5),A
   ret

key_dmp:
   in A,(5)
   dec A
   out (5),A
   ret

key_num:
   ld HL,0
   ld (temp_cursor_addr),HL
   ld A,0
   ld (c10c),A
   ROM_CALL(CLEARLCD)
   ld A,(key_pressed)
key_num_loop:
   ld E,0
   cp 55
   ret z
   cp 33
   JUMP_Z(key_num_0)
   cp 34
   JUMP_Z(key_num_1)
   cp 26
   JUMP_Z(key_num_2)
   cp 18
   JUMP_Z(key_num_3)
   cp 35
   JUMP_Z(key_num_4)
   cp 27
   JUMP_Z(key_num_5)
   cp 19
   JUMP_Z(key_num_6)
   cp 36
   JUMP_Z(key_num_7)
   cp 28
   JUMP_Z(key_num_8)
   cp 20
   JUMP_Z(key_num_9)
fin_k_n_l:
   call GET_KEY
   JUMP_(key_num_loop)


key_num_9:
  inc E
key_num_8:
  inc E
key_num_7:
  inc E
key_num_6:
  inc E
key_num_5:
  inc E
key_num_4:
  inc E
key_num_3:
  inc E
key_num_2:
  inc E
key_num_1:
  inc E
key_num_0:

  push DE

  ld HL,0
  ld DE,(temp_cursor_addr)
  ld B,10
mult_10_loop:
  add HL,DE
  djnz mult_10_loop

  pop DE

  ld D,0

  add HL,DE

  ld (temp_cursor_addr),HL

  ld A,(c10c)
  inc A
  ld (c10c),A
  cp 5
  jr z,last_ch_addr

  ld BC,0
  ld (CURSOR_ROW),BC
  ROM_CALL(D_HL_DECI)
  JUMP_(fin_k_n_l)

last_ch_addr:
  ld HL,(temp_cursor_addr)
  ld (cursor_addr),HL
  ld DE,73
  cp 0
  sbc HL,DE
  ld (debut_ecran),HL
  ld A,0
  ld (key_pressed),A
  ret

.end


